// fgfmc.cxx -- 
//
// Written by Harald Johnsen, started Juilly 2004.
//
// Copyright (C) 2004  Harald Johnsen  - hjohnsen@evc.net
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License as
// published by the Free Software Foundation; either version 2 of the
// License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//

#include <simgear/debug/logstream.hxx>

#include <GL/glut.h>
#include <plib/pu.h>

#include "fmc.hxx"
#include "fmcgui.hxx"
#include "fmcnav.hxx"
#include "fmccomm.hxx"
#include "fmcpages.hxx"
#include "fmcperf.hxx"

FMCGui	*fmcGui;
FMCPage *fmcPage;
FMCCom	*fmcCom;
FMCNav	*fmcNav;
FMCPerf *fmcPerf;

// from FG::fg_init.cxx

// Scan the command line options for the specified option and return
// the value.
static string fgScanForOption( const string& option, int argc, char **argv ) {
    int i = 1;

    SG_LOG(SG_GENERAL, SG_INFO, "Scanning command line for: " << option );

    int len = option.length();

    while ( i < argc ) {
	SG_LOG( SG_GENERAL, SG_DEBUG, "argv[" << i << "] = " << argv[i] );

	string arg = argv[i];
	if ( arg.find( option ) == 0 ) {
	    return arg.substr( len );
	}

	i++;
    }

    return "";
}



static void doInit(int argc, char **argv)
{
	string root, temp;
	char *envp;

	sglog().setLogLevels( SG_ALL, SG_INFO );

    root = fgScanForOption( "--fg-root=", argc, argv);
    // Next check if fg-root is set as an env variable
    if ( root.empty() ) {
        envp = ::getenv( "FG_ROOT" );
        if ( envp != NULL ) {
            root = envp;
        }
    }
    if ( root.empty() ) {
        root = "/FlightGear";
	}


	fmcCom = new FMCCom;

    temp = fgScanForOption( "--host=", argc, argv);
	if( ! temp.empty() )
		fmcCom->comHost = temp;

    temp = fgScanForOption( "--port=", argc, argv);
	if( ! temp.empty() )
		fmcCom->comPort = temp;

	fmcCom->comBind();

	fmcNav = new FMCNav;
	fmcNav->Init (root);

	fmcGui = new FMCGui;
	fmcPage = new FMCPage;
	fmcPerf = new FMCPerf;

	fmcGui->InitGui ( argc, argv );
	fmcPage->FMCReset();
	fmcPerf->init();

	glutMainLoop();
}




#ifdef _USRDLL

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    return TRUE;
}

extern "C"
__declspec( dllexport )  
void
__stdcall
fmcVBEntry (void)
{
	int argc=2;
	char *arg="VBCaller";
	char *argv[]={arg,"--fg-root=f:/flightgear/data","\0",NULL};
	doInit(argc, argv);
}

extern "C"
__declspec( dllexport )  
void
__stdcall
fmcVBEntry2 (void)
{

}

#else

int main (int argc, char **argv)
{
	doInit(argc, argv);
	return 0;
}


#endif
