// fmcData.cxx -- a library that manage a list of properties
//
// Written by Harald Johnsen, started Juilly 2004.
//
// Copyright (C) 2004  Harald Johnsen  - hjohnsen@evc.net
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License as
// published by the Free Software Foundation; either version 2 of the
// License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//


typedef enum dataType {
	dataTypeMissing = -1,
    dataTypeUnk = 0,
    dataTypeICAO = 1,
    dataTypeFix,
    dataTypePos,
    dataTypeElev
} dataType ;

extern bool DataSet(string name , string value, dataType theType = dataTypeMissing );
extern string DataGet(string name, bool fmt = true);
extern string fmtData(string data, dataType fmt, bool showempty = true);
extern string dataView(string data);
extern string dataPosWp(string wp);
extern bool isDataEmpty(string name);
extern void DataFixUnique(bool value);
extern string posToString(float pos , bool islon);
extern float StringTopos(string str, bool islon);
extern void extract_latlon(string data, float *lat, float *lon);
extern string latlon(float lat, float lon);
extern string format(float n, string fmt);
extern string format(string s, string fmt);
extern string unformat(string s, string fmt);

extern string ftos(float n);
extern float stof(string s);


extern void BatchGet(int count, char *FGproperties[], char *FMCproperties[]);


