// $Id: fgfsclient.cxx,v 1.1 2004/02/10 15:35:48 ehofman Exp $
// g++ -O2 -g -pedantic -Wall fgfsclient.cxx -o fgfsclient -lstdc++

#include <simgear/debug/logstream.hxx>
#include <plib/ul.h>
#include "fmccomm.hxx"

const int maxlen = 4090;
static string STR="";




FGFSSocket::init( string hostname, string port = "5501")
{
    channel = new SGSocket( hostname, port, "tcp" );
//	channel->set_timeout(1000);
	connected = channel->open( SG_IO_OUT );
}


void FGFSSocket::close(void)
{
	if(connected)
		channel->close();
	connected = false;
}


int FGFSSocket::write(const char *msg, ...)
{
	va_list va;
	int len;
	char buf[maxlen];

	va_start(va, msg);
	vsprintf(buf, msg, va);
	va_end(va);
//	std::cout << "SEND: " << buf << std::endl;
	strcat(buf, "\015\012");

	len = channel->writestring( buf );
	return len;
}


const char *FGFSSocket::read(void)
{
	static char buf[maxlen];
	char *p;
	int len;
	int loop = 0;

	do {
		len = channel->readline( buf, maxlen - 1 );

		if (len < 0)
			return 0;
		if( len == 0)
			ulMilliSecondSleep ( 100 );

	} while (len == 0 && loop++ < 10);
	if (len == 0)
		return 0;

	for (p = &buf[len - 1]; p >= buf; p--)
		if (*p != '\015' && *p != '\012')
			break;
	*++p = '\0';
//	SG_LOG(SG_GENERAL, SG_INFO, buf);
	return buf;
}





FMCCom::FMCCom(void)
{
    comHost = "127.0.0.1";
    comPort = "5501";
    comTimeout = 10;
    comActive = false;
}

void FMCCom::comBind()
{
	f.init (comHost, comPort);
	if(f.connected)
		f.write("data");
	comActive = f.connected;
}

void FMCCom::comDataSet(string property, string value)
{
	int lg;
    if(comActive)
	{
		lg = f.write("set %s %s", property.c_str(), value.c_str());
    }
}

string FMCCom::comDataGet(string property)
{
	if( ! comActive )
		return "";

	int lg = f.write("get %s", property.c_str());
	const char *p = f.read();

	if( ! p )
	{
		p = f.read();
		return "";
	}

	return p;
}

//ulClock timer;

string FMCCom::BatchGet(int count, char *properties[])
{
	if( ! comActive )
		return "";

	string cmd;
	int n;
	count --;
	for( n = 0 ; n <= count ; n++ )
	{
		cmd += STR + "get " + properties[n];
		if(n < count )
			cmd += "\015\012";
	}
	int lg = f.write( cmd.c_str() );

//	timer.reset();
	string result;
	for( n = 0; n <= count ; n++ )
	{
		const char *p = f.read();
		if( ! p )
		{
			SG_LOG(SG_GENERAL, SG_INFO, cmd);
			p = "";
		}
		result += STR + p + "\015\012";
	}
//	timer.update();
//	float t = timer.getDeltaTime();
//	char temp[80];
//	sprintf(temp, "time for com=%1.5f", t);
//	SG_LOG(SG_GENERAL, SG_INFO, temp);
	return result;
}
