// fmcNav.cxx	-- access to the navigation databases
//
// Written by Harald Johnsen, started Juilly 2004.
//
// Copyright (C) 2004  Harald Johnsen  - hjohnsen@evc.net
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License as
// published by the Free Software Foundation; either version 2 of the
// License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//


struct fmcRecord {

    int		type;
    float	lon, lat;            // location in geodetic coords
    float	elev_ft;
    float	x, y, z;             // location in cartesian coords (earth centered)
    int		freq;
    int		range;
    string	ident;			// navaid ident
    string	apt_id;			// corresponding airport id
};


#define MAX_RESULT		100

class FGNavList;
class FGFixList;
class FGAirportList;
class FGRunwayList;

class FMCNav {

private:

	void sortNav(void);

	// the NavRefpoint is used to sort the non unique nav names based on distance
	string NavRefpointPos;
	float NavRefpointlat, NavRefpointlon;

	FGNavList *navlist;
	FGFixList *fixlist;
	FGAirportList *airports;
	FGRunwayList *runways;


public:

	bool Init(string root);
	string nav_type_lib(int type);
	bool get_apt_pos(string ident, float *lat, float *lon);
	void SetNavRefpoint(string value);
	int get_wp_data(string ident, float *lat, float *lon, float *elev=NULL);
	int search_nav( string ident);
	int search_apt( string ident);
	int search_fix( string ident);
	int search_rwy( string ident);
	void ehsiHelper(double lon, double lat, float range, int type);

	fmcRecord search_result[MAX_RESULT];
	int search_result_count;
	string navcycle;
	string navdate;
};

