// fmcPages.cxx	-- display the fmc pages and handle user input
//				-- store all data in the property tree and access FG when needed
//
// Written by Harald Johnsen, started Juilly 2004.
//
// Copyright (C) 2004  Harald Johnsen  - hjohnsen@evc.net
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License as
// published by the Free Software Foundation; either version 2 of the
// License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//

#ifndef _FMCPAGES_HXX
#define _FMCPAGES_HXX  1

#include "fmcgui.hxx"

typedef enum  {
    ActNoOp,
    ActPage,
    ActData,
    ActDataConst,
    ActViewOnly,
    ActSpecial,
    ActSpecialEdit
} LSKActionType;



class FMCPage {

private:

	void EnableExec(string action);
	void SpecialEdit(int LSK);
	void SpecialAction(string action);

	void CopyModLegsToAct(void);
	void CopyActLegsToMod(void);
	void LegsPage(void);
	void RteDataPage(void);
	void ProgressPage(void);
	void PageLegsUpSelect(int LSK);
	void ActLegs(void);
	void RteToLegs(void);



	inline void DrawPage(int nbPage, string title, string l1="", string l2="", string l3="", string l4="", string l5="", string l6="")
	{
		fmcGui->DrawPage (nbPage, title, l1, l2, l3, l4, l5, l6);
	}

	inline void drawText(int ln, int side, char const *text)
	{
		fmcGui->drawText(ln, side, text);
	}

	LSKActionType LSKAction[12];
	string LSKData[12];
	int LSKPage[12];
	// add the fmt to the LSK now
	string LSKFmt[12];
	string ExecFunction;
	bool actRte;
	string operatingPhase;

public:
	FMCPage();

	void SetLSK(int num , string lib, LSKActionType actionType , string data="");
	void SetLSK(int num , string lib, LSKActionType actionType , PageType);
	void fmcDrawPage(int num);
	void LSKaction(int index);
	void DrawLSK(int num , string lib );
	void FMCReset(void);
	void SetMsg(string msg);
	void Execute();
	void shiftWP(void);
	void DataTimerFunc(int n);
	void PerfTimerFunc(int n);

	string ScratchPad;
	bool ScratchPadisMsg;
	int PageCount;
	int PageNumber;
	int currPage;
	string previousWP;



};

#endif
